Subject: Re: [PATCH net-next v1 0/6] ptp: Support hardware clocks with additional free running time

From: Vinicius Costa Gomes <[email-masked]>
Date: Thu, 24 Mar 2022 17:01:58 -0700

Hi,

Gerhard Engleder <[email-masked]> writes:

> ptp vclocks require a clock with free running time for the timecounter.
> Currently only a physical clock forced to free running is supported.
> If vclocks are used, then the physical clock cannot be synchronized
> anymore. The synchronized time is not available in hardware in this
> case. As a result, timed transmission with TAPRIO hardware support
> is not possible anymore.
>
> If hardware would support a free running time additionally to the
> physical clock, then the physical clock does not need to be forced to
> free running. Thus, the physical clocks can still be synchronized while
> vclocks are in use.
>
> The physical clock could be used to synchronize the time domain of the
> TSN network and trigger TAPRIO. In parallel vclocks can be used to
> synchronize other time domains.
>
> One year ago I thought for two time domains within a TSN network also
> two physical clocks are required. This would lead to new kernel
> interfaces for asking for the second clock, ... . But actually for a
> time triggered system like TSN there can be only one time domain that
> controls the system itself. All other time domains belong to other
> layers, but not to the time triggered system itself. So other time
> domains can be based on a free running counter if similar mechanisms
> like 2 step synchroisation are used.

I tried to look at this series from the point of view of the Intel i225
NIC and its 4 sets of timer registers, and thinking how adding support
for the "extra" 4 timers would fit with this proposal.

>From what I could gather, the idea that would make more sense would be
exposing the other(s?) i225 timers as vclocks. That sounds neat to me,
i.e. the extra timer registers are indeed other "views" to the same
clock (the name "virtual" makes sense).

When retrieving the timestamps from packets (we can timestamp each
packet with two timers), the driver knows what timestamp (and what to do
with it) the user is interested in.

Is this what you (and others) had in mind?

If so, API-wise this series looks good to me. I will take a closer look
at the code tomorrow.

>
> Synchronisation was tested with two time domains between two directly
> connected hosts. Each host run two ptp4l instances, the first used the
> physical clock and the second used the virtual clock. I used my FPGA
> based network controller as network device. ptp4l was used in
> combination with the virtual clock support patches from Miroslav
> Lichvar.
>
> v1:
> - comlete rework based on feedback to RFC (Richard Cochran)
>
> Gerhard Engleder (6):
>   ptp: Add cycles support for virtual clocks
>   ptp: Request cycles for TX timestamp
>   ptp: Pass hwtstamp to ptp_convert_timestamp()
>   ethtool: Add kernel API for PHC index
>   ptp: Support late timestamp determination
>   tsnep: Add physical clock cycles support
>
>  drivers/net/ethernet/engleder/tsnep_hw.h   |  9 ++-
>  drivers/net/ethernet/engleder/tsnep_main.c | 27 ++++++---
>  drivers/net/ethernet/engleder/tsnep_ptp.c  | 44 ++++++++++++++
>  drivers/ptp/ptp_clock.c                    | 58 +++++++++++++++++--
>  drivers/ptp/ptp_private.h                  | 10 ++++
>  drivers/ptp/ptp_sysfs.c                    | 10 ++--
>  drivers/ptp/ptp_vclock.c                   | 18 +++---
>  include/linux/ethtool.h                    |  8 +++
>  include/linux/ptp_clock_kernel.h           | 67 ++++++++++++++++++++--
>  include/linux/skbuff.h                     | 11 +++-
>  net/core/skbuff.c                          |  2 +
>  net/ethtool/common.c                       | 13 +++++
>  net/socket.c                               | 45 +++++++++++----
>  13 files changed, 275 insertions(+), 47 deletions(-)
>
> -- 
> 2.20.1
>

-- 
Vinicius